/*============================================================================
|   Copyright (C) 2001-2003  Jonathan Harm
|
|
|   This program is free software; you can redistribute it and/or
|   modify it under the terms of the GNU General Public License
|   as published by the Free Software Foundation; either version 2
|   of the License, or (at your option) any later version.
|   This program is distributed in the hope that it will be useful,
|   but WITHOUT ANY WARRANTY; without even the implied warranty of
|   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
|   GNU General Public License for more details.
|   You should have received a copy of the GNU General Public License
|   along with this program; if not, write to the Free Software
|
|   Foundation, Inc.,
|   59 Temple Place - Suite 330
|   Boston, MA  02111-1307, USA.
|
|
|
|                   insert_query.c REV 8 for SQL Query Generator
|
|
|  This program is under the GPL see http://www.gnu.org for more info
|
|
|                   http://change.to/opensource
|                   110983@lycos.com
|
\============================================================================*/
 #include "querygen.h"




void insert_query( void ) {

      

  extern char out[MAX];
  extern char ctqfile[MAX];		                        // this is the CREATE TABLE query file
  char ins_string[BIGBUF] = "INSERT INTO ";
  char val_string[BIGBUF] = "VALUES(";
  char *tablename;
  int user_done;                                     //ask user if they are done(this will be either Y or N)
  int loop_done = 0;                                      //used to controll while loop
  int i = 0;                                              //for counting
  extern int appendfile;                           //option for appending output file
  extern int printstdout;                           //option to print the output to stdout
  extern int useoutputfile;                       //see comment about this in querygen.h and main.c
  sqltable *column;                                 //the pointer to the struct


  // these are the user input variables
  int           input_smallint;
  long        input_integer;
  float        input_floatingpoint;
  char        inputstring[MAX];
  char        *p_inputstring = inputstring;
  extern char *p_addslash;  //will point to output_buffer from addslash()
  char        inputbuffer[MAX];



    
  // file descriptors for this module
  FILE *fpctq, *fpout;

   

  //First open "ctq" in read only mode and open "out" for writing

  if( (fpctq = fopen(ctqfile, "r")) == NULL) {
    fprintf(stderr, "\nCouldn't open file %s\n", ctqfile);
    exit(1);
    }


  
if(useoutputfile == 1)
{
        
  if(appendfile == 1)
  {

       if( (fpout = fopen(out, "a")) == NULL)
       {
         fprintf(stderr, "\nCouldn't create file %s\n", out);
         exit(2);
       }

   }


   else
   {

         if( (fpout = fopen(out, "w")) == NULL)
         {
             fprintf(stderr, "\nCouldn't create file %s\n", out);
             exit(2);
          }

   }



   fprintf(fpout, "/* This file made by SQL Query Generator %.1f*/\n", PROGRAM_VERSION);
   fprintf(fpout, "/* go to http://change.to/opensource for the latest updates */\n\n\n");

}


 while(loop_done == 0)
 {

          strcpy(ins_string, "INSERT INTO "); //reset ins_string before using strcat()
          strcpy(val_string, "VALUES(");

       
       // Asks the user what table they want to make a query for      
        if( (tablename = gettable(fpctq)) == 0)
        exit(1);
          
         //add the tablename and ( to ins_string
         strcat(ins_string, tablename);
         strcat(ins_string, "(");


         //go to the correct place in fpctq to read columns for the table the user selected
         if( gototable(fpctq, tablename) == 1)
           { fprintf(stderr, "Error: Invalid table name\n"); exit(1); }


 //when the loop starts, start a sub-loop that will get the column names and ask the user
 //for input.  These will be written to the output file according to the data type of the column
  while(   ((column = getcolumn(fpctq)) != 0)   )  
  {
           strcat(ins_string, column->name);
           strcat(ins_string, ", ");

//make this NULL so when the program checks to see if the user
//entered something for a column that is NOT NULL it will only
//let them continue until something is entered
inputstring[0] = '\0';

        printf("\nEnter value for %s (datatype %s) ", column->name, column->type);


       if(column->null == 1)
       {
            while(inputstring[0] == '\0')
            {

              fgets(inputstring, BIGBUF, stdin); //this is where the user types the value to put in the column
              inputstring[strlen(inputstring)-1] = '\0';

            }

           
            
        } //end if(column->null == 1)

       else //just do it once if the column can be null
       {
           fgets(inputstring, BIGBUF, stdin);
           inputstring[strlen(inputstring)-1] = '\0';
           
       }


            //add backslashes before single quotes
            p_addslash = addslash(p_inputstring);
            strcpy(inputstring, p_addslash);


       
          //now check the data type and use appropriate method of getting user input
          //after getting input from user, put the data into the val_string

          if( strcmp(column->type,"SMALLINT") == 0 )
          {

             input_smallint = atoi(inputstring);
                   sprintf(inputbuffer, "%d", input_smallint);
                   strcat(val_string, inputbuffer);
                   strcat(val_string, ", ");
          }



           else if( strcmp(column->type,"TINYINT") == 0 )
          {
                   sprintf(inputbuffer, "%s", inputstring);
                   strcat(val_string, inputbuffer);
                   strcat(val_string, ", ");
          }



          else if( strcmp(column->type,"INTEGER") == 0 || strcmp(column->type, "REAL") == 0)
          {
             input_integer = atoi(inputstring);
                    sprintf(inputbuffer, "%ld", input_integer);
                    strcat(val_string, inputbuffer);
                    strcat(val_string, ", ");
          }



          else if( strcmp(column->type,"FLOAT") == 0 )
          {

             input_floatingpoint = atof(inputstring);
                   sprintf(inputbuffer, "%f", input_floatingpoint);
                   strcat(val_string, inputbuffer);
                   strcat(val_string, ", ");
           }



          else if( strcmp(column->type,"CHAR") == 0 )
          {
                 strcat(val_string, "\'");
                 strcat(val_string, inputstring);
                 strcat(val_string, "\'");
                 strcat(val_string, ", ");
            }



           else
           {
             printf("\nData type %s not supported\n", column->type);
             exit(1);
           }


} //end of loop that fills up the val_string

     /* now we have to take off the last comma and replace with ')'
        In order to do this efficiently, we will have to find the NULL character by searching
        from the beginning to the end of the string.  Then start searching backwards from the
        NULL character for a comma(it should be right before the NULL character).  After finding
        the NULL character, replace it with a  ")"  */


     for(i = 0; i < BIGBUF; i++)
     {
               if( ins_string[i] == '\0')
               {
                    ins_string[i -= 2] = ')';
                    break;
               }
     }
  


                   //before placing val_string into the file, change the last comma to a ")"
                  for(i = 0; i < BIGBUF; i++)
                  {
                        if( val_string[i] == '\0')
                        {
                             val_string[i -= 2] = ')';
                             break;
                        }

                    }

 
            if(printstdout == 1)
            {
              printf("\nHere is your query:\n\n\n");
              printf("%s\n", ins_string);
              printf("%s;\n\n", val_string);
            }
      
           if(useoutputfile == 1)
           { 
              //ok, now put the INSERT INTO and VALUES strings in the file
              fprintf(fpout, "%s\n", ins_string);
              fprintf(fpout, "%s;\n\n", val_string);
           }


           printf("\n\nAre you done making INSERT INTO queries?(y/N)");


            user_done = toupper(getc(stdin));



              switch (user_done) {

                 case 'Y' :

                     printf("\nThank you for using SQL Query Generator %.1f.\n", PROGRAM_VERSION);

                      //close files before exiting
                      if(useoutputfile == 1) fclose(fpout);  //only close the file if it was opened
                      fclose(fpctq);

                      loop_done = 1;
                      break;


                 case 'N' :
                       loop_done = 0;
                       getc(stdin); //eat newline here so user wont have to press enter twice for default option                           
                       break;


                 default :
                        loop_done = 0;                                                                              
                            break;

                } //end of switch




     } //end of while loop


exit(0);


} //end of insert_query


