/*============================================================================
|   Copyright (C) 2001-2003  Jonathan Harm
| 
| 
|   This program is free software; you can redistribute it and/or 
|   modify it under the terms of the GNU General Public License 
|   as published by the Free Software Foundation; either version 2 
|   of the License, or (at your option) any later version. 
|   This program is distributed in the hope that it will be useful, 
|   but WITHOUT ANY WARRANTY; without even the implied warranty of 
|   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
|   GNU General Public License for more details. 
|   You should have received a copy of the GNU General Public License 
|   along with this program; if not, write to the Free Software 
|    
|   Foundation, Inc.,  
|   59 Temple Place - Suite 330 
|   Boston, MA  02111-1307, USA. 
| 
|   
| 
|                   update_query.c REV 8 or SQL Query Generator
| 
|  This program is under the GPL see http://www.gnu.org for more info 
| 
|   
|                   http://change.to/opensource 
|                   110983@lycos.com 
| 
\============================================================================*/ 


#include "querygen.h"


void update_query( void )
{



  extern char out[MAX];
  extern char ctqfile[MAX];		                    // this is the CREATE TABLE query file
  char update_query[BIGBUF];                 //this is what is written to the file
  char set_string[BIGBUF];                      //the SET column = 'something' string
  char *unique_query;  
  char input_string[BIGBUF];                   //for the user to input the data to update the column
  char *p_input_string = input_string;
  extern char *p_addslash;                      //this is defined in querygen.h
  char update_column[MAX];                   //the column to be updated
  char *tablename;
  int user_done;                                      //ask user if they are done(this will be either Y or N)
  int loop_done = 0;                                  //used to control when the while loop ends
  int update_col_only_done = 0;               //used to control when user is done updating columns only
  int update_row_done = 0;
  extern int appendfile;                            //option for appending output file
  extern int printstdout;                           //option to print output to stdout
  extern int useoutputfile;                          //see querygen.h
  char col_or_row;                                   //when asking user "[C]olumn or [R]ow"
  sqltable *column;                                  //used for finding the datatype of a column



  FILE *fpctq, *fpout;




  //First open "ctq" in read only mode and open "out" for writing

  if( (fpctq = fopen(ctqfile, "r")) == NULL) {
    fprintf(stderr, "\nCouldn't open file %s\n", ctqfile);
    exit(1);
    }


if(useoutputfile == 1)
{   

     if(appendfile == 1)
     {

         if( (fpout = fopen(out, "a")) == NULL)
         {
           fprintf(stderr, "\nCouldn't create file %s\n", out);
           exit(2);
          }

     }

     else
     {

         if( (fpout = fopen(out, "w")) == NULL)
         {
             fprintf(stderr, "\nCouldn't create file %s\n", out);
             exit(2);
          }

     }




  fprintf(fpout, "\n/* This file made by SQL Query Generator %.1f*/\n", PROGRAM_VERSION);
  fprintf(fpout, "/* go to http://change.to/opensource for the latest updates */\n\n\n");

} //end of "if(useoutputfile == 1)"




//in this loop, ask what column to update
//and weather to update the whole column
  while( loop_done == 0 )
  {

      input_string[0] = '\0'; //set to null for error checking


       if( (tablename = gettable(fpctq)) == NULL)
      exit(1);

      
      /*ask user if they want to update the entire
        column or just 1 row */

      printf("\nWould you like to update an entire [C]olumn or only specific [R]ow(s)? ");
        col_or_row = toupper(  fgetc(stdin) );
        getc(stdin); //eat newline character so fgets doesn't get it



      if( col_or_row == 'C')
      {

        while(update_col_only_done == 0)
        {

           printf("\nWhat column do you want to update? ");
           fgets(update_column, MAX, stdin);  update_column[strlen(update_column)-1] = '\0';
           //remove newline char and replace it with NULL

           //make sure the column the user types in exists
           if( gototable(fpctq, tablename) == 1)
             {fprintf(stderr, "Error: Invalid table name\n"); exit(1); }
              

             while(1)  //this loop checks to make sure the user typed in a column that exists in fpctq
             {
                   if( (column = getcolumn(fpctq)) == NULL)
                        { fprintf(stderr, "column \"%s\" is not in the table \"%s\"\n", update_column, tablename); exit(1); }

                     if( strcmp(update_column, column->name) == 0)
                     break;

              }

              
            //prompt user to input data, then write it to the output file
            printf("\nNow type in the information to update \"%s\": ", update_column);

            //do column->null error checking
            if(column->null == 1)
            {
                   while(input_string[0] == '\0')
                   {
                        fgets(input_string, MAX, stdin);   input_string[strlen(input_string)-1] ='\0';
                   }
                   
            }

             else { fgets(input_string, MAX, stdin);   input_string[strlen(input_string)-1] ='\0'; }

                        p_addslash = addslash(p_input_string);
                        strcpy(p_input_string, p_addslash);
             

                       //for now, just check to see if it is or isn't numerical
                        if( strcmp(column->type, "CHAR") == 0)
                         sprintf(update_query, "UPDATE %s\nSET %s = \'%s\'", tablename, update_column, input_string);


                        else
                         sprintf(update_query, "UPDATE %s\nSET %s = %s", tablename, update_column, input_string);


            if(printstdout ==1)
             printf("\nHere is your query\n\n%s;\n\n\n", update_query);
                         
            if(useoutputfile == 1)
            fprintf(fpout, "%s;\n\n", update_query);


        printf("\n\nDo you want to make more queries that only update entire columns?(Y/n)");

       update_col_only_done = toupper(getc(stdin));

       switch (update_col_only_done) {

                 case 'Y' :
                      update_col_only_done = 0;
                      memset(input_string, '\0', BIGBUF);
                      getc(stdin); //eat newline
                      break;

                 case 'N' :
                       update_col_only_done = 1;
                       getc(stdin); //eat newline
                       break;

                 default :
                        update_col_only_done = 0;
                        memset(input_string, '\0', BIGBUF);
                        break;

                } //end of switch

            
         }//  end  while(update_col_only_done == 0)

         
    }      //end   if( col_or_row == 'C')




        else if(col_or_row == 'R')
        {
          strcpy(set_string, "SET ");
          sprintf(update_query, "UPDATE %s\n", tablename);
          while(update_row_done == 0)
          {
        
               //so the user only wants to update certain row(s).
               //TODO:  display list of columns for user (version 0.3 or later)
               //1. ask user what column  contains information unique to the row(s) they want to update
               //2. ask user what that information is

              printf("\nWhat column do you want to update? ");
              fgets(update_column, MAX, stdin);  update_column[strlen(update_column)-1] = '\0';
              //remove newline char and replace it with NULL    

            if(gototable(fpctq, tablename) == 1)
              { fprintf(stderr, "Error: Invalid table name\n"); exit(1); }
             
             while(1)  //this loop checks to make sure the user typed in a column that exists in fpctq
             {
                   if( (column = getcolumn(fpctq)) == NULL)
                        { fprintf(stderr, "column \"%s\" is not in the table \"%s\"\n", update_column, tablename); exit(1); }
                   
                     if( strcmp(update_column, column->name) == 0)
                     break;

              }

              
            //prompt user to input data, then write it to the update_query string
            printf("\nNow type in the information to update \"%s\": ", update_column);

            //do column->null error checking
            if(column->null == 1)
            {
                   while(input_string[0] == '\0')
                   {
                        fgets(input_string, MAX, stdin);   input_string[strlen(input_string)-1] ='\0';
                   }
            }

             else { fgets(input_string, MAX, stdin);   input_string[strlen(input_string)-1] ='\0'; }

            p_addslash = addslash(p_input_string);
            strcpy(p_input_string, p_addslash);

             
             strcat(set_string, update_column);
             strcat(set_string, " = ");      



         /*==================================================================*/
                 /*= deal with qoutes that may or may not need to be around input_string==*/
                 if(gototable(fpctq, tablename) == 1)
                   { fprintf(stderr, "Error: Invalid table name\n"); exit(1); }
                while( (column = getcolumn(fpctq)) != 0)
               {
                
                   if( strcmp(column->name, update_column) == 0)
                   {
                       //first of all, if the column type isn't CHAR, then it must be a numerical type
                       //check to make sure the user only enters numbers for numerical datatypes
                       if( strcmp(column->type,"CHAR") != 0)
                       {
                          //put code here to check for numbers(use isdigit in a loop)
                          //it would be a good idea to handle floating point numbers too
                       }

                   
                     if( strcmp(column->type,"SMALLINT") == 0)
                      {
                        strcat(set_string, input_string);
                      }


                     else if( strcmp(column->type,"TINYINT") == 0)
                      {
                        strcat(set_string, input_string);
                      }


                     else if( strcmp(column->type,"FLOAT") == 0)
                      {
                         strcat(set_string, input_string);
                      }


                     else if( strcmp(column->type,"INTEGER") == 0 || strcmp(column->type,"REAL") == 0)
                      {
                         strcat(set_string, input_string);
                      }


          /*
         //               Done with the numerical data.  Everything below this line
         //               will only deal with character type data.
         //=====================================================*/


                      else if( strcmp(column->type,"CHAR") == 0)
                       {
                         strcat(set_string, "\'");
                         strcat(set_string, input_string);
                         strcat(set_string, "\'");                        
                         break;
                       }


                    // if the datatype of the column the user entered data for
                    // was not in the above if statement, then that datatype is
                    // not supported
                    else
                     {
                       fprintf(stderr, "Datatype %s not supported\n", column->type);
                     }

                }
                

            } //end   while( (column = getcolumn(fpctq)) != 0

                     
            


           
        printf("\n\nDo you want to make more updates to the row(s)?(Y/n)");

       update_row_done = toupper(getc(stdin));

       switch (update_row_done) {

                 case 'Y' :
                      update_row_done = 0;
                      strcat(update_query, set_string);
                      strcat(update_query, ",\n");
                      memset(set_string, '\0', BIGBUF);

                      //if a column is NOT NULL then we want to make sure that input_string[0] is null
                      memset(input_string, '\0', BIGBUF);
                      getc(stdin); //eat newline

                      break;

                 case 'N' :
                       update_row_done = 1;
                       strcat(update_query, set_string);
                       strcat(update_query, "\n");                     
                       getc(stdin); //eat newline
                       break;

                 default :
                        update_row_done = 0;
                        strcat(update_query, set_string);
                        strcat(update_query, ",\n");
                        memset(set_string, '\0', BIGBUF);

                         //if a column is NOT NULL then we want to make sure that input_string[0] is null
                        memset(input_string, '\0', BIGBUF);
                        break;

                } //end of switch



            } //end while(update_row_done == 0)


            //1. ask user what column contains the unique info
            // Also use getcolumn() to get the datatype
           // printf("\nWhat column contains the information unique to the row(s) you want to update? ");
         //  fgets(unique_column, MAX, stdin);  unique_column[strlen(unique_column)-1] = '\0';

            unique_query = where_clause(fpctq, tablename);
            
     
            if(printstdout == 1)   
             printf("\nHere is your query:\n\n\n%s%s;\n\n", update_query, unique_query);


            if(useoutputfile == 1)
            fprintf(fpout, "%s%s;\n\n", update_query, unique_query);

            
         } //end of "else if(col_or_row == 'R')"



         else
         {
            fprintf(stderr, "You did not enter C or R\n");
            exit(1);
         }


     printf("\n\nAre you done making UPDATE queries?(y/N)");

       user_done = toupper(getc(stdin));


       switch (user_done) {

                 case 'Y' :
                      printf("\nThank you for using SQL Query Generator %.1f.\n", PROGRAM_VERSION);
                      //close files before exiting
                      if(useoutputfile == 1) fclose(fpout);
                      fclose(fpctq);
                      loop_done = 1;
                      break;


                 case 'N' :
                       loop_done = 0;            //reset the variables that control the loops
                       update_row_done = 0;
                       update_col_only_done = 0;                  
                       getc(stdin); //eat newline
                       break;


                 default :
                        loop_done = 0;
                        update_row_done = 0;
                        update_col_only_done = 0;                                       
                        break;

                } //end of switch


  } //end while loop



exit(0);

}




