 /*============================================================================ 
|   Copyright (C) 2003  Jonathan Harm                                           
| 
| 
|   This program is free software; you can redistribute it and/or 
|   modify it under the terms of the GNU General Public License 
|   as published by the Free Software Foundation; either version 2 
|   of the License, or (at your option) any later version. 
|   This program is distributed in the hope that it will be useful, 
|   but WITHOUT ANY WARRANTY; without even the implied warranty of 
|   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
|   GNU General Public License for more details. 
|   You should have received a copy of the GNU General Public License 
|   along with this program; if not, write to the Free Software 
|    
|   Foundation, Inc.,  
|   59 Temple Place - Suite 330 
|   Boston, MA  02111-1307, USA. 
| 
|   
| 
|                   where_clause.c INITIAL for SQL Query Generator
| 
|  This program is under the GPL see http://www.gnu.org for more info 
| 
|   
|                   http://change.to/opensource 
|                   110983@lycos.com 
| 
\============================================================================*/ 


#include "querygen.h"

char *where_clause(FILE *fpctq, char *tablename)
{

   static char where_clause[BIGBUF];         //this contains the entire WHERE clause
   char tmp_clause[BIGBUF];                     //this will get strcat'ed to where_clause with "AND" or "OR" as the glue
   char where_operator[9];                         //7 is the largest number of characters a WHERE operator can have
   char input_string[9];                                //what the user types in for the where operator
   char unique_info[MAX];                          //the info unique to the column(s)
   char unique_column[MAX];
   char *p_unique_info = unique_info;
   char glue[MAX];                                 //the glue is what is put between tmp_clauses that are strung together in where_clause
   char valid_where_operators[12][9] = { {"="}, {"<>"}, {"!="}, {"<"},   //list of valid where operators to check for
                                                          {"<="}, {"!<"}, {">"}, {">="},
                                                          {"!>"}, {"BETWEEN"},
                                                          {"LIKE"}, {"IS NULL"} };
   extern char *p_addslash;                       //this is what addslash returns
   int user_done = 0, loop_done = 0;          //used for controlling loops
   int where_op_loop_done = 0;                //see above
   int i;                                                    //just a counter   
   sqltable *column;                                  //used for finding the datatype of a column
   extern int verbosewhere;                     //the verbose where option

 // used for converting a string to a numerical
 //datatype when creating the unique_query string
  char        input_tinyint;
  int           input_smallint;
  long        input_integer;
  float        input_floatingpoint;


   //set the default to = if user didn't select the verbose option
   if(verbosewhere == 0)
   strcpy(where_operator, "=");
   else strcpy(where_operator, "");	
   
//the where_clasue has to start with this
strcpy(where_clause, "WHERE ");


       
 while(loop_done == 0)
{
            
            unique_column[0] = '\0'; //set to null so user will have to enter something for unique_column
                        
            // ask user what column contains the unique info
            printf("\nWhat column contains the information unique to the row(s) you are making this query for? ");
            while(unique_column[0] == '\0') 
             {  fgets(unique_column, MAX, stdin);  unique_column[strlen(unique_column)-1] = '\0'; }


            //check to see if user typed in a valid column name
            if(gototable(fpctq, tablename) == 1)
             { fprintf(stderr, "Error: Invalid table name\n"); exit(1); }


             while(1)  //this loop checks to make sure the user typed in a column that exists in fpctq
             {
                   if( (column = getcolumn(fpctq)) == NULL)
                        { fprintf(stderr, "column \"%s\" is not in the table \"%s\"\n", unique_column, tablename); exit(1); }

                     if( strcmp(unique_column, column->name) == 0)
                     break;
              }

              
         //here is where we ask what WHERE operator the user wants to use
         if(verbosewhere == 1)
         {
              where_op_loop_done = 0; //reset to run the loop again
             while(where_op_loop_done == 0)
             {
                printf("Type in the WHERE operator you want to use[%s] ", where_operator);
                fgets(input_string, 9, stdin); input_string[strlen(input_string)-1] = '\0';
                
                   //if the user didn't press enter copy what they typed to where_operator
                   //if they did press enter, then where_operator will not change
                   if(input_string[0] != '\0') strcpy(where_operator, input_string);

                //make where_operator upper case
                for(i = 0; i < 9; i++) { where_operator[i] = toupper(where_operator[i]); }

             //check to make sure the user typed a valid where operator
                for(i = 0; i < 12; i++)
                {                  
                  if(strcmp(where_operator, valid_where_operators[i]) == 0)
                  where_op_loop_done = 1;
                }

                  //if we got to here and where_op_loop_done is still 0, then the user typed and
                  //invalid WHERE operator
                  if(where_op_loop_done == 0) {
                   printf("You typed an invalid WHERE operator, these are the operators you can use:\n");
                   printf("\n=, <>, !=, <, <=, !<, >, >=, !>, BETWEEN, LIKE, IS NULL\n");
                   //clear where_operator so it wont be the default next time around
                   strcpy(where_operator, "");
                   }



            }//end of while(where_op_loop_done ==0)
         } //end of    if(verbosewhere == 1)


      if(strcmp(where_operator, "IS NULL") != 0)
      {
         if(strcmp(where_operator, "BETWEEN") == 0)
         {  //ask user for first value, strcat an "AND" to the clause then ask for second value
            strcpy(tmp_clause, unique_column);
            strcat(tmp_clause, " BETWEEN ");

            printf("\nWhat is the lower value for this clause? ");
            fgets(unique_info, MAX, stdin);   unique_info[strlen(unique_info)-1] = '\0';

            //now strcat that, then AND to tmp_clause
            strcat(tmp_clause, unique_info);
            strcat(tmp_clause, " AND ");

            printf("\nWhat is the higher value for this clause? ");
            fgets(unique_info, MAX, stdin);   unique_info[strlen(unique_info)-1] = '\0';            

            strcat(tmp_clause, unique_info);            
            
         }


         if(strcmp(where_operator, "BETWEEN") != 0)
         {
            // ask user to type in the information unique to that row(s)
            printf("\nNow type data contained in \"%s\" that is\nunique to the row(s) you are making this query for: ", unique_column);
            fgets(unique_info, MAX, stdin);   unique_info[strlen(unique_info)-1] = '\0';

            // add slashes to unique_info (if needed)
            p_addslash = (p_unique_info);
            strcpy(p_unique_info, p_addslash);
         

          if(gototable(fpctq, tablename) == 1)
           { fprintf(stderr, "Error: Invalid table name\n"); exit(1); }


              
            while( (column = getcolumn(fpctq)) != 0)
            {

                 //as soon as the column name is found check to see if it is numerical or string
                 //datatype so the program can put quotes around numerical data and leave
                 //qoutes off of strings
                 if( strcmp(column->name, unique_column) == 0)
                 {

                   //first take care of numerical datatypes

                     if( strcmp(column->type,"SMALLINT") == 0)
                      {
                        input_smallint = atoi(unique_info);
                        sprintf(tmp_clause, "%s %s %d", unique_column, where_operator, input_smallint);
                      }


                     else if( strcmp(column->type,"TINYINT") == 0)
                      {
                        input_tinyint = atoi(unique_info);
                        sprintf(tmp_clause,"%s %s %d", unique_column, where_operator, input_tinyint);
                      }


                     else if( strcmp(column->type,"FLOAT") == 0)
                      {
                        input_floatingpoint = atoi(unique_info);
                        sprintf(tmp_clause,"%s %s %f", unique_column, where_operator, input_floatingpoint);
                      }


                     else if( strcmp(column->type,"INTEGER") == 0 || strcmp(column->type,"REAL") == 0)
                      {
                        input_integer = atoi(unique_info);
                        sprintf(tmp_clause,"%s %s %ld", unique_column, where_operator, input_integer);
                     }


          /*
         //               Done with the numerical data.  Everything below this line
         //               will only deal with character type data.
         //=====================================================*/


                      else if( strcmp(column->type,"CHAR") == 0)
                         sprintf(tmp_clause,"%s %s \'%s\'", unique_column, where_operator, unique_info);


                    // if the datatype of the column the user entered data for
                    // was not in the above if statement, then that datatype is
                    // not supported
                    else  fprintf(stderr, "Datatype %s not supported\n", column->type);

                 }


            } //  end of   while( (column = getcolumn(fpctq)) != 0)

          } //end of if(strcmp(where_operator, "BETWEEN") != 0)
             
    } //end of  if(strcmp(where_operator, "IS NULL") != 0)


    if(strcmp(where_operator, "IS NULL") == 0)
   {              //handle the IS NULL clause
            strcpy(tmp_clause, unique_column);
            strcat(tmp_clause, " IS NULL");
   }
          
           
   if(verbosewhere == 1)
   {
      printf("\n\nAre you done with the WHERE clauses for this query?(Y/n)");

       user_done = toupper(getc(stdin));


       switch (user_done) {

                 case 'Y' :
                      loop_done = 1;
                      strcat(where_clause, tmp_clause);
                      getc(stdin); //eat newline
                      break;


                 case 'N' :
                       //ask what "glue" (AND || OR) and make a switch for it here
                        getc(stdin); //eat newline

                          while( (strcmp(glue, "AND") != 0) && (strcmp(glue, "OR")) )
                          {
                                 printf("What would you like the next WHERE clause connected with(AND/OR)? ");
                                 fgets(glue, MAX, stdin); glue[strlen(glue)-1] = '\0';


                                 //now make glue uppper case
                                 for(i = 0; i < 3; i++)
                                 { glue[i] = toupper(glue[i]); }

                            }
                           strcat(where_clause, tmp_clause);
                           strcat(where_clause, " "); strcat(where_clause, glue); strcat(where_clause, " ");
                           memset(tmp_clause, '\0', BIGBUF);                     
                           strcpy(glue, ""); //clear the glue string so it can be used again
                       break;


                 default :
                        loop_done = 1;
                        strcat(where_clause, tmp_clause);
                      break;

                } //end of switch

  } //end of   if(verbosewhere ==1)

  else {
  //if user isn't using verbose where option, then they wont need to run
  //through the loop again
  loop_done = 1;
  strcat(where_clause, tmp_clause);
  }

}//end loop

  return where_clause;

} //end of the function
